GUID joyGUID[4];
static int joyF[4];
static int joycounter;
LPDIRECTINPUTDEVICE2 lpJoy[4]={0,0,0,0};
int JoyXCenter[4],JoyYCenter[4];
DIJOYSTATE JoyStatus;

void JoyAutoRestore(HRESULT ddrval,LPDIRECTINPUTDEVICE2 lpJJoy)
{
   switch(ddrval)
    {
     case DIERR_INPUTLOST:
     case DIERR_NOTACQUIRED:
                           IDirectInputDevice2_Acquire(lpJJoy);
                           break;
    }
}

unsigned long GetJSOr(void)
{
unsigned long ret;
int x;
ret=0;

for(x=0;x<4;x++)
 {
 if(joy[x])
  {
   ddrval=IDirectInputDevice2_Poll(lpJoy[x]);
   if(ddrval!=DD_OK) JoyAutoRestore(ddrval,lpJoy[x]);

   ddrval=IDirectInputDevice2_GetDeviceState(lpJoy[x],sizeof(JoyStatus),&JoyStatus);
   if(ddrval!=DD_OK) JoyAutoRestore(ddrval,lpJoy[x]);

   if(JoyStatus.lX>=JoyXCenter[x]+(JoyXCenter[x]>>1))
    ret|=JOY_RIGHT<<(x<<3);
   else if(JoyStatus.lX<=JoyXCenter[x]>>1)
    ret|=JOY_LEFT<<(x<<3);

   if(JoyStatus.lY>=JoyYCenter[x]+(JoyYCenter[x]>>1))
    ret|=JOY_DOWN<<(x<<3);
   else if(JoyStatus.lY<=JoyYCenter[x]>>1)
    ret|=JOY_UP<<(x<<3);

   if(JoyStatus.rgbButtons[joyA[x]&31]&0x80) ret|=1<<(x<<3);
   if(JoyStatus.rgbButtons[joyB[x]&31]&0x80) ret|=2<<(x<<3);
   if(JoyStatus.rgbButtons[joySelect[x]&31]&0x80) ret|=4<<(x<<3);
   if(JoyStatus.rgbButtons[joyStart[x]&31]&0x80) ret|=8<<(x<<3);
  }
 }
return ret;
}


void KillJoystick(void)
{
 int x;
 for(x=0;x<4;x++)
 {
  if(lpJoy[x])
  {
   IDirectInputDevice2_Unacquire(lpJoy[x]);
   IDirectInputDevice2_Release(lpJoy[x]);
   lpJoy[x]=0;
  }
 }
}


HRESULT IDirectInput_CreateDevice2(LPDIRECTINPUT pdi,
                                   REFGUID rguid,
                                   LPDIRECTINPUTDEVICE2 *ppdev2,
                                   LPUNKNOWN punkOuter)
{
    LPDIRECTINPUTDEVICE pdev;
    HRESULT hres;

    hres = IDirectInput_CreateDevice(pdi, rguid, &pdev, punkOuter);

    if (SUCCEEDED(hres)) {
    hres = pdev->lpVtbl->QueryInterface(pdev,
                       &IID_IDirectInputDevice2,
                              (LPVOID *)ppdev2);
    IDirectInputDevice_Release(pdev);
    } else {
    *ppdev2 = 0;
    }
    return hres;
}
BOOL CALLBACK JoystickFound(LPCDIDEVICEINSTANCE lpddi, LPVOID pvRef)
{
   int x;
   for(x=0;x<4;x++)
    if(joy[x]==joycounter)
    {
     joyF[x]=1;
     joyGUID[x]=lpddi->guidInstance;
    }
   return DIENUM_CONTINUE;
}


void InitJoystick(void)
{
int x;
for(x=0;x<4;x++) joyF[x]=0;
joycounter=1;
puts("Enumerating joysticks...");
IDirectInput_EnumDevices(lpDI, DIDEVTYPE_JOYSTICK,JoystickFound,0,
DIEDFL_ATTACHEDONLY);
for(x=0;x<4;x++)
 if(!joyF[x]) joy[x]=0;

for(x=0;x<4;x++)
 {
  if(!joy[x]) continue;
  ddrval=IDirectInput_CreateDevice2(lpDI, &joyGUID[x],&lpJoy[x],0);
  if (ddrval != DI_OK)
  {
   printNonFatal("DirectInput: Error creating DirectInput joystick device.");
   joy[x]=0;
   continue;
  }
  ddrval=IDirectInputDevice2_SetCooperativeLevel(lpJoy[x], hAppWnd,
DISCL_BACKGROUND|DISCL_NONEXCLUSIVE);
  if (ddrval != DI_OK)
  {
   printNonFatal("DirectInput: Error setting DirectInput joystick cooperative level.");
   joy[x]=0;
   continue;
  }
  ddrval=IDirectInputDevice2_SetDataFormat(lpJoy[x],&c_dfDIJoystick);
  if (ddrval != DI_OK)
  {
   printNonFatal("DirectInput: Error setting DirectInput joystick data format.");
   joy[x]=0;
   continue;
  }
  ddrval=IDirectInputDevice2_Acquire(lpJoy[x]);
  if (ddrval != DI_OK)
  {
   printNonFatal("DirectInput: Error acquiring DirectInput joystick.");
   joy[x]=0;
   continue;
  }
  IDirectInputDevice2_Poll(lpJoy[x]);
  ddrval=IDirectInputDevice2_GetDeviceState(lpJoy[x],sizeof(JoyStatus),&JoyStatus);
  if (ddrval != DI_OK)
  {
   printNonFatal("DirectInput: Error getting DirectInput joystick state.");
   joy[x]=0;
   continue;
  }

  JoyXCenter[x]=JoyStatus.lX;
  JoyYCenter[x]=JoyStatus.lY;
 }
x=joy[0]|joy[1]|joy[2]|joy[3];
if(x) x=1;
DriverInterface(DES_JOYSTICK,&x);
}

BOOL CALLBACK JoystickSearch(LPCDIDEVICEINSTANCE lpddi, LPVOID pvRef)
{
  SendDlgItemMessage(pvRef,106,CB_ADDSTRING,0,(LPARAM)(LPSTR)lpddi->tszProductName);
  SendDlgItemMessage(pvRef,111,CB_ADDSTRING,0,(LPARAM)(LPSTR)lpddi->tszProductName);
  SendDlgItemMessage(pvRef,112,CB_ADDSTRING,0,(LPARAM)(LPSTR)lpddi->tszProductName);
  SendDlgItemMessage(pvRef,113,CB_ADDSTRING,0,(LPARAM)(LPSTR)lpddi->tszProductName);

  return DIENUM_CONTINUE;
}


BOOL CALLBACK JoyConCallB(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int x;
  switch(uMsg) {
   case WM_INITDIALOG:
                SendDlgItemMessage(hwndDlg,106,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");
                SendDlgItemMessage(hwndDlg,111,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");
                SendDlgItemMessage(hwndDlg,112,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");
                SendDlgItemMessage(hwndDlg,113,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");

                for(x=0;x<4;x++)
                {
                 SetDlgItemInt(hwndDlg,200+x,joySelect[x],0);
                 SetDlgItemInt(hwndDlg,204+x,joyStart[x],0);
                 SetDlgItemInt(hwndDlg,212+x,joyA[x],0);
                 SetDlgItemInt(hwndDlg,208+x,joyB[x],0);
                }
                IDirectInput_EnumDevices(lpDI, DIDEVTYPE_JOYSTICK,JoystickSearch,hwndDlg,DIEDFL_ATTACHEDONLY);
                SendDlgItemMessage(hwndDlg,106,CB_SETCURSEL,joy[0],(LPARAM)(LPSTR)0);
                SendDlgItemMessage(hwndDlg,111,CB_SETCURSEL,joy[1],(LPARAM)(LPSTR)0);
                SendDlgItemMessage(hwndDlg,112,CB_SETCURSEL,joy[2],(LPARAM)(LPSTR)0);
                SendDlgItemMessage(hwndDlg,113,CB_SETCURSEL,joy[3],(LPARAM)(LPSTR)0);

                break;
   case WM_CLOSE:
   case WM_QUIT: goto gornk;
   case WM_COMMAND:
                if(!(wParam>>16))
                switch(wParam&0xFFFF)
                {
                 case 1:
                        gornk:
                        joy[0]=SendDlgItemMessage(hwndDlg,106,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
                        joy[1]=SendDlgItemMessage(hwndDlg,111,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
                        joy[2]=SendDlgItemMessage(hwndDlg,112,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
                        joy[3]=SendDlgItemMessage(hwndDlg,113,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);

                        for(x=0;x<4;x++)
                        {
                         joySelect[x]=GetDlgItemInt(hwndDlg,200+x,0,0);
                         joyStart[x]=GetDlgItemInt(hwndDlg,204+x,0,0);
                         joyA[x]=GetDlgItemInt(hwndDlg,212+x,0,0);
                         joyB[x]=GetDlgItemInt(hwndDlg,208+x,0,0);
                        }                        
                        EndDialog(hwndDlg,0);
                        break;
               }
              }
  return 0;
}

void ConfigJoystickies(void)
{
 KillJoystick();
 DialogBox(fceu_hInstance,"JOYCONFIG",hAppWnd,JoyConCallB);
 InitJoystick();
}

