#define INITGUID
#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <winsock.h>
#include <mmsystem.h>
#include <directx.h>
#include <dir.h>
#include "../../driver.h"
#include "../../general.h"

void ResetVideo(void);
void ShowCursorAbs(int w);
void HideFWindow(int h);
int SetMainWindowStuff(void);
int GetClientAbsRect(LPRECT lpRect);
void UpdateFCEUWindow(void);


LPDIRECTINPUT lpDI;
HINSTANCE fceu_hInstance;
HRESULT  ddrval;
HANDLE ThreadHandle;

#define JOY_A   1
#define JOY_B   2
#define JOY_SELECT      4
#define JOY_START       8
#define JOY_UP  0x10
#define JOY_DOWN        0x20
#define JOY_LEFT        0x40
#define JOY_RIGHT       0x80

static char BaseDirectory[2048];
static int toexit=0;

void CreateDirs(void)
{
 mkdir(BaseDirectory);
 sprintf(TempArray,"%s\\fcs",BaseDirectory);
 mkdir(TempArray);
 sprintf(TempArray,"%s\\snaps",BaseDirectory);
 mkdir(TempArray);
}

static char gfsdir[2048];
void GetBaseDirectory(void)
{
 int x;
 BaseDirectory[0]=0;
 GetModuleFileName(0,(LPTSTR)BaseDirectory,2047);

 for(x=strlen(BaseDirectory);x>=0;x--)
 {
  if(BaseDirectory[x]=='\\' || BaseDirectory[x]=='/')
   {BaseDirectory[x]=0;break;}
 }
}

void BlockingCheck(void)
{
  MSG msg;
  while( PeekMessage( &msg, 0, 0, 0, PM_NOREMOVE ) ) {
     if( GetMessage( &msg, 0,  0, 0)>0 )
     {
     TranslateMessage(&msg);
     DispatchMessage(&msg);     
     if(toexit) DriverInterface(DES_EXIT,0);
     }
   } 
}

int joyA[4]={1,1,1,1};
int joyB[4]={0,0,0,0};
int joySelect[4]={2,2,2,2};
int joyStart[4]={3,3,3,3};

int joy[4]={0,0,0,0};
int joyvar[32];
HWND hAppWnd=0;
byte vretrace=1;

static int soundflush=0;
static long ZK;
static long ZL;
static int genie=0;
static int palyo=0;
static int windowedfailed;
static int WindowXC=1<<30,WindowYC;
static int fullscreen=0;
static int vmod=1;
static int soundo=1;
static int ssync=1;
static int dowait=1;
static int ntsccol=0;

static int soundplevel=2;
static int soundwait=4;

void PrintFatalError(char *s)
{
 if(fullscreen) ShowCursorAbs(1);
 MessageBox(0,s,"Fatal Error",MB_ICONERROR|MB_OK|MB_SETFOREGROUND|MB_TOPMOST);
 if(fullscreen)ShowCursorAbs(0);
}

void printNonFatal(char *str)
{
 if(fullscreen) ShowCursorAbs(1);
 MessageBox(0,str,"Non-Fatal Error",MB_ICONWARNING|MB_OK|MB_SETFOREGROUND|MB_TOPMOST);
 if(fullscreen) ShowCursorAbs(0);
}

void ShowAboutBox(void)
{
 sprintf(TempArray,"FCE Ultra "VERSION_STRING"\n\nhttp://fceultra.sourceforge.net");
 MessageBox(hAppWnd,TempArray,"About FCE Ultra",MB_OK);
}
#include "joystick.c"
#include "config.c"
#include "keyboard.c"
#include "netplay.c"
#include "sound.c"
#include "video.c"
#include "window.c"
static int gong=0;
int DriverInitialize(void)
{
  int t;
  t=1;
  if(!InitializeDDraw()) return 0;
  InitJoystick();
  if(soundo)
  {
   soundo=InitSound();
   if(soundo) {soundo=44100;DriverInterface(DES_SOUND,&soundo);soundo=1;}
  }
  if(!SetVideoMode())
   {
   if(!fullscreen)
    {
     fullscreen=1;
     if(!SetVideoMode())
      return 0;
    }
   else
    return 0;
   }
  KeyboardInitialize();
  gong=1;
  return 1;
}

int main(int argc,char *argv[])
{
  char *t;


  fceu_hInstance=GetModuleHandle(0);
  CreateMainWindow();
  ddrval=DirectInputCreate(fceu_hInstance,DIRECTINPUT_VERSION,&lpDI,0);
  if(ddrval!=DI_OK)
  {
   PrintFatalError("DirectInput: Error creating DirectInput object.");
   return 0;
  }
  GetBaseDirectory();
  DriverInterface(DES_BASEDIR,BaseDirectory);
  CreateDirs();
  sprintf(TempArray,"%s\\fceu.cfg",BaseDirectory);
  LoadConfig(TempArray);
  t=0;
  if(argc>1)
   t=argv[1];
  if(!t) fullscreen=0;
  UpdateMenu();

  {
   int ret;
   ret=fceumain(t);
   return ret;
  }
}


void DriverKill(void)
{
 sprintf(TempArray,"%s/fceu.cfg",BaseDirectory);
 SaveConfig(TempArray);
 if(gong)
 {
  if(joy[0]|joy[1]|joy[2]|joy[3]) KillJoystick();
  KeyboardClose();
  ResetVideo();
  if(soundo) TrashSound();
 }
}

void UpdateDriver(void)
{
 UpdateFCEUWindow();
 Sleep(0);
}
