#define VF_SCALED	1

#define VEF_LOSTSURFACE 1
#define VEF____INTERNAL 2

static int mustrestore=0;
static int bpp;
static int vflags;
static int veflags;

static const int xres[9]={320,512,640,640,640,640,1024,1280,1600};
static const int yres[9]={240,384,480,480,480,480,768,1024,1200};

unsigned long *palettetranslate=0;

PALETTEENTRY color_palette[256];
static int PaletteChanged=0;

LPDIRECTDRAWCLIPPER lpClipper;
LPDIRECTDRAW  lpDD;
LPDIRECTDRAW4 lpDD4=0;
LPDIRECTDRAWPALETTE lpddpal=0;

DDSURFACEDESC2 ddsd;

DDSURFACEDESC2        ddsdback;
LPDIRECTDRAWSURFACE4  lpDDSPrimary=0;
LPDIRECTDRAWSURFACE4  lpDDSBack=0;

int RestoreDD(int w)
{
 if(w)
  {if(IDirectDrawSurface4_Restore(lpDDSBack)!=DD_OK) return 0;}
 else
  {if(IDirectDrawSurface4_Restore(lpDDSPrimary)!=DD_OK) return 0;}
  veflags|=1;
 return 1;
}

void SetPalette(unsigned char index, unsigned char r, unsigned char g, unsigned char b)
{
color_palette[index].peRed=r;
color_palette[index].peGreen=g;
color_palette[index].peBlue=b;
PaletteChanged=1;
}

void GetPalette(unsigned char i, unsigned char *r, unsigned char *g, unsigned char *b)
{
*r=color_palette[i].peRed;
*g=color_palette[i].peGreen;
*b=color_palette[i].peBlue;
}

int InitializeDDraw(void)
{
  ddrval = DirectDrawCreate ( NULL, &lpDD, NULL);
  if (ddrval != DD_OK)
  {
   PrintFatalError("DirectDraw: Error creating DirectDraw object.");
   return 0;
  }
  ddrval = IDirectDraw_QueryInterface(lpDD,&IID_IDirectDraw4,(LPVOID *)&lpDD4);
  if (ddrval != DD_OK)
  {
   PrintFatalError("DirectDraw: Error querying interface.");
   return 0;
  }
  IDirectDraw_Release(lpDD);
  return 1;
}

int SetVideoMode(void)
{
 DDCAPS caps;
 vflags=0;
 veflags=1;
 PaletteChanged=1;

 caps.dwSize=sizeof(caps);
 if(IDirectDraw4_GetCaps(lpDD4,&caps,0)!=DD_OK)
 {
    PrintFatalError("DirectDraw: Error getting capabilities.");
    return 0;
 }

 ResetVideo();

 if(!fullscreen)
 {
  DDPIXELFORMAT ddpix;

  ShowCursorAbs(1);
  windowedfailed=1;
  HideFWindow(0);
  SetMainWindowStuff();

  ddrval = IDirectDraw4_SetCooperativeLevel ( lpDD4, hAppWnd, DDSCL_NORMAL);
  if (ddrval != DD_OK)
  {
   PrintFatalError("DirectDraw: Error setting cooperative level.");
   return 1;
  }
  /* Beginning */
   memset(&ddsdback,0,sizeof(ddsdback));
   ddsdback.dwSize=sizeof(ddsdback);
   ddsdback.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
   ddsdback.ddsCaps.dwCaps= DDSCAPS_LOCALVIDMEM | DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY;

   ddsdback.dwWidth=256;
   ddsdback.dwHeight=240;
   ddrval = IDirectDraw4_CreateSurface ( lpDD4, &ddsdback, &lpDDSBack, (IUnknown FAR*)NULL);
   if (ddrval != DD_OK)
   {
    PrintFatalError("DirectDraw: Error creating secondary surface.");
    return 1;
   }
   memset(&ddsd,0,sizeof(ddsd));
   ddsd.dwSize = sizeof(ddsd);
   ddsd.dwFlags = DDSD_CAPS;
   ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
   ddrval = IDirectDraw4_CreateSurface ( lpDD4, &ddsd, &lpDDSPrimary,(IUnknown FAR*)NULL);
   if (ddrval != DD_OK)
   {
    PrintFatalError("DirectDraw: Error creating primary surface.");
    return 1;
   }
   memset(&ddpix,0,sizeof(ddpix));
   ddpix.dwSize=sizeof(ddpix);
   ddrval=IDirectDrawSurface4_GetPixelFormat(lpDDSPrimary,&ddpix);
   if (ddrval != DD_OK)
   {
    PrintFatalError("DirectDraw: Error getting primary surface pixel format.");
    return 1;
   }
   if(ddpix.dwFlags&DDPF_RGB)
    bpp=ddpix.DUMMYUNIONNAMEN(1).dwRGBBitCount;
   else
    {
     PrintFatalError("DirectDraw: RGB data not valid.");
     return 1;
    }
   if(bpp!=16 && bpp!=24 && bpp!=32)
   {
     PrintFatalError("DirectDraw: Current bit depth not supported!");
     return 1;
   }
   if(bpp==16)
    palettetranslate=malloc(65536*4);
   else
    palettetranslate=malloc(256*4);

   ddrval=IDirectDraw4_CreateClipper(lpDD4,0,&lpClipper,0);
   if (ddrval != DD_OK)
   {
    PrintFatalError("DirectDraw: Error creating clipper.");
    return 1;
   }
   ddrval=IDirectDrawClipper_SetHWnd(lpClipper,0,hAppWnd);
   if (ddrval != DD_OK)
   {
    PrintFatalError("DirectDraw: Error setting clipper window.");
    return 1;
   }
   ddrval=IDirectDrawSurface4_SetClipper(lpDDSPrimary,lpClipper);
   if (ddrval != DD_OK)
   {
    PrintFatalError("DirectDraw: Error attaching clipper to primary surface.");
    return 1;
   }
   windowedfailed=0;
 /* Ending */
 }
 else
 {
  HideFWindow(1);
  ddrval = IDirectDraw4_SetCooperativeLevel ( lpDD4, hAppWnd,DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);
  if (ddrval != DD_OK)
  {
   PrintFatalError("DirectDraw: Error setting cooperative level.");
   return 0;
  }

  switch(vmod)
  {
   case 1:ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 320, 240, 8,0,0);break;
   case 2:ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 512, 384, 8,0,0);break;
   case 3:
   case 4:
   case 5:
   case 6: 
           ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 640, 480, 8,0,0);break;
   case 7: ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 1024, 768, 8,0,0);break;
   case 8: ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 1280, 1024, 8,0,0);break;
   case 9: ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 1600, 1200, 8,0,0);break;
  }
  if (ddrval != DD_OK)
  {
   PrintFatalError("DirectDraw: Error setting display mode.");
   return 0;
  }
   if(vmod>=6)
    {
    if(caps.dwCaps&DDCAPS_BLTSTRETCH)
     vflags|=1;
    else if(vmod==6)
     goto nostretch;
    memset(&ddsdback,0,sizeof(ddsdback));
    ddsdback.dwSize=sizeof(ddsdback);
    ddsdback.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsdback.ddsCaps.dwCaps= DDSCAPS_LOCALVIDMEM | DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY;

    if(vmod==7 || vmod==8)
     ddsdback.dwHeight=256;
    else
     ddsdback.dwHeight=240;

    if(vmod>=7)
     ddsdback.dwWidth=256;
    else
     ddsdback.dwWidth=320;
    ddrval = IDirectDraw4_CreateSurface ( lpDD4, &ddsdback, &lpDDSBack, (IUnknown FAR*)NULL);
    if(ddrval!=DD_OK) vflags&=~1;
    }
  nostretch:
  // create foreground surface
  memset(&ddsd,0,sizeof(ddsd));
  ddsd.dwSize = sizeof(ddsd);
  ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
  ddsd.ddsCaps.dwCaps = DDSCAPS_VIDEOMEMORY | DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
  ddsd.dwBackBufferCount = 1;
  ddrval = IDirectDraw4_CreateSurface ( lpDD4, &ddsd, &lpDDSPrimary,(IUnknown FAR*)NULL);
  if (ddrval != DD_OK)
  {
   PrintFatalError("DirectDraw: Error creating primary surface.");
   return 0;
  }
  memset(&lpddpal,0x00,sizeof(lpddpal));
  ddrval=IDirectDraw4_CreatePalette( lpDD4, DDPCAPS_8BIT|DDPCAPS_ALLOW256|DDPCAPS_INITIALIZE,color_palette,&lpddpal,NULL);
  if (ddrval != DD_OK)
  {
   PrintFatalError("DirectDraw: Error creating palette object.");
   return 0;
  }
  ddrval=IDirectDrawSurface4_SetPalette(lpDDSPrimary, lpddpal);
  if (ddrval != DD_OK)
  {
   PrintFatalError("DirectDraw: Error setting palette object.");
   return 0;
  }
  mustrestore=1;
  ShowCursorAbs(0);
 }
return 1;
}
void BlitScreenWindow(unsigned char *XBuf, int maxline);
void BlitScreenFull(unsigned char *XBuf, int maxline);

void BlitScreen(unsigned char *XBuf, int maxline)
{
 static int maxlinep=0;

 if(maxlinep!=maxline) {veflags|=1;maxlinep=maxline;}
 UpdateFCEUWindow();
 if(fullscreen)
  BlitScreenFull(XBuf,maxline);
 else if(!windowedfailed)
  BlitScreenWindow(XBuf,maxline);

}

void BlitScreenWindow(unsigned char *XBuf, int maxline)
{
 int x,y;
 int pitch;
 unsigned char *ScreenLoc;
 static RECT srect={0,0,256,240};
 RECT drect;

 if(PaletteChanged==1)
 {
  int x;
  if(bpp>=24)
  {
   for(x=0;x<256;x++)
   {
    uint32 t;
    t=0;
    t=color_palette[x].peBlue;
    t|=color_palette[x].peGreen<<8;
    t|=color_palette[x].peRed<<16;
    palettetranslate[x]=t;
   }
  }
  else if(bpp==16)
  {
   for(x=0;x<65536;x++)
   {     // red 6 bits, b 6 bits, g 5 bits
    unsigned short lower,upper;
   
    lower=(color_palette[x&255].peRed>>3)<<11;
    lower|=(color_palette[x&255].peGreen>>2)<<5;
    lower|=(color_palette[x&255].peBlue>>3);

    upper=(color_palette[x>>8].peRed>>3)<<11;
    upper|=(color_palette[x>>8].peGreen>>2)<<5;
    upper|=(color_palette[x>>8].peBlue>>3);      
    palettetranslate[x]=lower|(upper<<16);
   }
  }
  PaletteChanged=0;
 }
 if(!GetClientAbsRect(&drect)) return;

 ddrval=IDirectDrawSurface4_Lock(lpDDSBack,NULL,&ddsdback, 0, NULL);
 if(ddrval!=DD_OK)
 {
  if(ddrval==DDERR_SURFACELOST) RestoreDD(1);
  return;
 }
 pitch=ddsdback.DUMMYUNIONNAMEN(1).lPitch;
 ScreenLoc=ddsdback.lpSurface;
 if(veflags&1)
 {
  memset(ScreenLoc,0,pitch*240);
  veflags&=~1;
 }
 switch(bpp)
 {
  case 32:
   for(y=maxline;y;y--)
   {
    for(x=256;x;x--)
    {
     static uint32 tmp;
     tmp=palettetranslate[(uint32)*XBuf];
     *(uint32 *)ScreenLoc=tmp;
     ScreenLoc+=4;
     XBuf++;
    }
    XBuf+=16;
   }
  break;
  case 24:
   for(y=maxline;y;y--)
   {
    for(x=256;x;x--)
    {
     static uint32 tmp;
     tmp=palettetranslate[(uint32)*XBuf];
     *(uint16*)ScreenLoc=(uint16)tmp;
     //*&ScreenLoc[1]=(uint8)(tmp>>8);
     *&ScreenLoc[2]=(uint8)(tmp>>16);
     ScreenLoc+=3;
     XBuf++;
    }
    XBuf+=16;
   }
        break;
  case 16:
   for(y=maxline;y;y--)
   {
    for(x=128;x;x--)
    {
     *(unsigned long *)ScreenLoc=palettetranslate[*(unsigned short *)XBuf];
     ScreenLoc+=4;
     XBuf+=2;
    }
    XBuf+=16;
   }
   break;
 }
 IDirectDrawSurface4_Unlock(lpDDSBack, NULL);
 ddrval=IDirectDrawSurface4_Blt(lpDDSPrimary, &drect,lpDDSBack,&srect,DDBLT_WAIT,0);
}

void BlitScreenFull(unsigned char *XBuf, int maxline)
{
  static int pitch;
  char *ScreenLoc;
  unsigned long x;
  byte y;

  if(PaletteChanged==1)
   {
    ddrval=IDirectDrawPalette_SetEntries(lpddpal,0,0,256,color_palette);
    if(ddrval!=DD_OK)
    {
     if(ddrval==DDERR_SURFACELOST) RestoreDD(0);
     return;
    }
   PaletteChanged=0;
   }
 if(vflags&1)
 {
  ddrval=IDirectDrawSurface4_Lock(lpDDSBack,NULL,&ddsdback, 0, NULL);

  if(ddrval!=DD_OK)
  {
   if(ddrval==DDERR_SURFACELOST) RestoreDD(1);
   return;
  }

 ScreenLoc=ddsdback.lpSurface;
 pitch=ddsdback.DUMMYUNIONNAMEN(1).lPitch;

 }
 else
 {
  ddrval=IDirectDrawSurface4_Lock(lpDDSPrimary,NULL,&ddsd, 0, NULL);

  if(ddrval!=DD_OK)
  {
   if(ddrval==DDERR_SURFACELOST) RestoreDD(0);
   return;
  }

 ScreenLoc=ddsd.lpSurface;
 pitch=ddsd.DUMMYUNIONNAMEN(1).lPitch;
 }
 if(veflags&1)
  {
   switch(vmod)
   {
   default: memset((char *)ScreenLoc,0x80,pitch*240);break;
   case 2: memset((char *)ScreenLoc,0x80,pitch*384);break;
   case 3:
   case 4:
   case 5:

   case 9: veflags|=2;
   case 6: if(vflags&1) {veflags|=2;memset((char *)ScreenLoc,0x80,pitch*240);}
           else memset((char *)ScreenLoc,0x80,pitch*480);
           break;
   case 8:
   case 7: veflags|=2;memset((char *)ScreenLoc,0x80,pitch*256);break;
   }
   PaletteChanged=1;
   veflags&=~1;
  }
 if(vmod==5)
 {
  asm volatile(
     "xorl %%edx, %%edx\n\t"
     "koop1:\n\t"
     "movb $128,%%al     \n\t"
     "koop2:\n\t"
     "movb 1(%%esi),%%dl\n\t"
     "shl  $16,%%edx\n\t"
     "movb (%%esi),%%dl\n\t"
     "orl $0x80008000,%%edx\n\t"
     "movl %%edx,(%%edi)\n\t"
     "addl $2,%%esi\n\t"
     "addl $4,%%edi\n\t"
     "decb %%al\n\t"
     "jne koop2\n\t"
     "addl $16,%%esi\n\t"
     "addl %%ecx,%%edi\n\t"
     "decb %%bl\n\t"
     "jne koop1\n\t"
     :
     : "S" (XBuf), "D" (ScreenLoc+((240-maxline)/2)*pitch+(640-512)/2),
"b" (maxline), "c" (pitch-512+pitch)
     : "%al", "%edx", "%cc" );

 }
else if(vmod==4)
{
asm volatile(
     "yoop1:\n\t"
     "movb $128,%%al     \n\t"
     "yoop2:\n\t"
     "movb 1(%%esi),%%dh\n\t"
     "movb %%dh,%%dl\n\t"
     "shl  $16,%%edx\n\t"
     "movb (%%esi),%%dl\n\t"
     "movb %%dl,%%dh\n\t"               // Ugh
     "movl %%edx,(%%edi)\n\t"
     "addl $2,%%esi\n\t"
     "addl $4,%%edi\n\t"
     "decb %%al\n\t"
     "jne yoop2\n\t"
     "addl $16,%%esi\n\t"
     "addl %%ecx,%%edi\n\t"
     "decb %%bl\n\t"
     "jne yoop1\n\t"
     :
     : "S" (XBuf), "D" (ScreenLoc+((240-maxline)/2)*pitch+(640-512)/2),
"b" (maxline), "c" (pitch-512+pitch)
     : "%al", "%edx", "%cc" );
}
else if(vmod==6 && !(vflags&1))
{
asm volatile(
     "yyoop1:\n\t"
     "movb $128,%%al     \n\t"
     "yyoop2:\n\t"
     "movb 1(%%esi),%%dh\n\t"
     "movb %%dh,%%dl\n\t"
     "shl  $16,%%edx\n\t"
     "movb (%%esi),%%dl\n\t"
     "movb %%dl,%%dh\n\t"               // Ugh
     "movl %%edx,(%%edi)\n\t"
     "movl %%edx,640(%%edi)\n\t"
     "addl $2,%%esi\n\t"
     "addl $4,%%edi\n\t"
     "decb %%al\n\t"
     "jne yyoop2\n\t"

     "addl $16,%%esi\n\t"
     "addl %%ecx,%%edi\n\t"
     "decb %%bl\n\t"
     "jne yyoop1\n\t"
     :
     : "S" (XBuf), "D" (ScreenLoc+((240-maxline)/2)*pitch+(640-512)/2),"b" (maxline), "c" (pitch-512+ddsd.DUMMYUNIONNAMEN(1).lPitch)
     : "%al", "%edx", "%cc" );
 }
else switch(vmod)
 {
  case 9:
        ScreenLoc += ((240-maxline)>>1)*pitch;
        goto defaulx;
  case 8:
  case 7:
        ScreenLoc += ((240-maxline)>>1)*pitch+(pitch<<3);
        goto defaulx;
  case 6:
  case 1:
        ScreenLoc += ((240-maxline)>>1)*pitch+32;
        goto defaulx;
  case 2:
        ScreenLoc += ((384-maxline)>>1)*pitch+128;
        goto defaulx;

  case 3:
        ScreenLoc += ((640-256)>>1)+ ((480-maxline)>>1)*pitch;

  defaulx:
  for(y=maxline;y;y--)
   {
    for(x=64;x;x--)
     {
     *(long *)ScreenLoc=*(long *)XBuf;
     ScreenLoc+=4;
     XBuf+=4;
     }
    ScreenLoc+=pitch-256;
    XBuf+=16;
   }
  break;

 }
 if(vflags&1)
  {
  RECT drect,srect;

  drect.left=0;
  drect.right=xres[vmod-1];
  drect.top=0;
  drect.bottom=yres[vmod-1];

  if(vmod==9)
   {drect.left=32;drect.right=1568;}

  srect.left=0;
  if(vmod==7 || vmod==8 || vmod==9)
   srect.right=256;
  else
   srect.right=320;

  srect.top=0;
  if(vmod==7 || vmod==8)
   srect.bottom=256;
  else
   srect.bottom=240;

  IDirectDrawSurface4_Unlock(lpDDSBack, NULL);

  if(veflags&2)
  {
   if(IDirectDrawSurface4_Lock(lpDDSPrimary,NULL,&ddsd, 0, NULL)==DD_OK)
   {
    memset(ddsd.lpSurface,0x80,ddsd.DUMMYUNIONNAMEN(1).lPitch*yres[vmod-1]);
    IDirectDrawSurface4_Unlock(lpDDSPrimary, NULL);
    veflags&=~2;
   }
  }
  ddrval=IDirectDrawSurface4_Blt(lpDDSPrimary, &drect,lpDDSBack,&srect,DDBLT_WAIT,0);
  if(ddrval!=DD_OK)
   {
    if(ddrval==DDERR_SURFACELOST)
    {
     RestoreDD(0);
     RestoreDD(1);
    }
    return;
   }
  }
 else
  IDirectDrawSurface4_Unlock(lpDDSPrimary, NULL);
}

void WaitForVBlank(void)
{
 if(dowait)
 {
  if(ssync && soundo)
  {
   wackyer:
    if(vretrace)
    {
    vretrace--;
    }
    else
    {
    BlockingCheck();
    Sleep(0);
    goto wackyer;
    }
 }
 else if(!ssync)
  IDirectDraw_WaitForVerticalBlank(lpDD4,DDWAITVB_BLOCKBEGIN,0);
 }
}

void ResetVideo(void)
{
 ShowCursorAbs(1);
 if(palettetranslate) {free(palettetranslate);palettetranslate=0;}
 if(lpDD4)
  if(mustrestore)
   {IDirectDraw4_RestoreDisplayMode(lpDD4);mustrestore=0;}
 if(lpDDSBack) {IDirectDrawSurface4_Release(lpDDSBack);lpDDSBack=0;}
 if(lpDDSPrimary) {IDirectDrawSurface4_Release(lpDDSPrimary);lpDDSPrimary=0;}
 if(lpddpal) {IDirectDrawPalette_Release(lpddpal);lpddpal=0;}
}
